import controlP5.*;
import processing.serial.*;

Serial Bluetooth;

ControlP5 cp5;

Slider2D s;
Slider f;
Button b;

int btn=255;
int btnON=color (255, 0, 0);
int btnOFF=color (9, 46, 92);
int btnOVERoff=color (150, 0, 0);
int btnOVERon=color (16, 111, 179);
int xCampo = 1000; //larghezza campo in mm
int yCampo = 1000; //altezza campo in mm

void setup() {
  size(700, 400);
  cp5 = new ControlP5(this);    
  // PUNTATORE
  s = cp5.addSlider2D("position")
    .setPosition((700-200*xCampo/yCampo)/2, 50)
    .setSize(200*xCampo/yCampo, 200)
    .setMinMax(0, yCampo, xCampo, 0)
    .setValue(0, 0)
    .disableCrosshair()
    .setColorActive(color(btn))

    ;
  // BANG
  b = cp5.addButton("bang")
    .setValue(0)
    .setPosition((700-200*xCampo/yCampo)/2, 270)
    .setSize(200*xCampo/yCampo, 80)
    ;


  smooth();

  f = cp5.addSlider("feedrate")
  .setPosition((700-200*xCampo/yCampo)/2, 20)
  .setRange(0, 10000)
  .setSize(200*xCampo/yCampo, 10)
  .setNumberOfTickMarks(5)
  .setSliderMode(Slider.FLEXIBLE)
  ;

  cp5.getController("feedrate").getValueLabel().align(ControlP5.LEFT, ControlP5.BOTTOM_OUTSIDE).setPaddingX(0) .setPaddingY(-20);
  cp5.getController("feedrate").getCaptionLabel().align(ControlP5.RIGHT, ControlP5.BOTTOM_OUTSIDE).setPaddingX(0) .setPaddingY(-20);

  Bluetooth=new Serial(this, Serial.list()[1], 115200);
}

float cnt;
void draw() {
  background(0);

  if ( Bluetooth.available() > 0) {  //put the incoming data into a String - 
    //the '\n' is our end delimiter indicating the end of a complete packet
    String val = Bluetooth.readStringUntil('\n');
    //make sure our data isn't empty before continuing
    if (val != null) {
      //trim whitespace and formatting characters (like carriage return)
      val = trim(val);
      println(val);
      switch(val) {
      case "0":
        Bluetooth.write ("M4\n");
        b.setColorBackground(color(btnON));
        b.setColorForeground(color(btnOVERon));
        break;

      case "1":
        Bluetooth.write ("M3\n");
        b.setColorBackground(color(btnOFF));
        b.setColorForeground(color(btnOVERoff));

      default:
        break;
      }
    }
  }
}


public void bang(int theValue) {
  float [] position=s.getArrayValue(); //restituisce un array 
  println("bang  X: "+floor(position[0]) + " Y: " +floor( position[1]));
  //Bluetooth.write ("x100"+floor(position[0]) + " Y" +floor( position[1])+" F"+f.getValue()+"\n");
  //Bluetooth.write ("y100"+floor(position[0]) + " Y" +floor( position[1])+" F"+f.getValue()+"\n");
  //Bluetooth.write ("w100"+floor(position[0]) + " Y" +floor( position[1])+" F"+f.getValue()+"\n");

  Bluetooth.write ("x100\n");
  Bluetooth.write ("y100\n");
  Bluetooth.write ("w100\n");
}





/*
a list of all methods available for the Slider2D Controller
 use ControlP5.printPublicMethodsFor(Slider2D.class);
 to print the following list into the console.
 
 You can find further details about class Slider2D in the javadoc.
 
 Format:
 ClassName : returnType methodName(parameter type)
 
 
 controlP5.Controller : CColor getColor() 
 controlP5.Controller : ControlBehavior getBehavior() 
 controlP5.Controller : ControlWindow getControlWindow() 
 controlP5.Controller : ControlWindow getWindow() 
 controlP5.Controller : ControllerProperty getProperty(String) 
 controlP5.Controller : ControllerProperty getProperty(String, String) 
 controlP5.Controller : ControllerView getView() 
 controlP5.Controller : Label getCaptionLabel() 
 controlP5.Controller : Label getValueLabel() 
 controlP5.Controller : List getControllerPlugList() 
 controlP5.Controller : Pointer getPointer() 
 controlP5.Controller : Slider2D addCallback(CallbackListener) 
 controlP5.Controller : Slider2D addListener(ControlListener) 
 controlP5.Controller : Slider2D addListenerFor(int, CallbackListener) 
 controlP5.Controller : Slider2D align(int, int, int, int) 
 controlP5.Controller : Slider2D bringToFront() 
 controlP5.Controller : Slider2D bringToFront(ControllerInterface) 
 controlP5.Controller : Slider2D hide() 
 controlP5.Controller : Slider2D linebreak() 
 controlP5.Controller : Slider2D listen(boolean) 
 controlP5.Controller : Slider2D lock() 
 controlP5.Controller : Slider2D onChange(CallbackListener) 
 controlP5.Controller : Slider2D onClick(CallbackListener) 
 controlP5.Controller : Slider2D onDoublePress(CallbackListener) 
 controlP5.Controller : Slider2D onDrag(CallbackListener) 
 controlP5.Controller : Slider2D onDraw(ControllerView) 
 controlP5.Controller : Slider2D onEndDrag(CallbackListener) 
 controlP5.Controller : Slider2D onEnter(CallbackListener) 
 controlP5.Controller : Slider2D onLeave(CallbackListener) 
 controlP5.Controller : Slider2D onMove(CallbackListener) 
 controlP5.Controller : Slider2D onPress(CallbackListener) 
 controlP5.Controller : Slider2D onRelease(CallbackListener) 
 controlP5.Controller : Slider2D onReleaseOutside(CallbackListener) 
 controlP5.Controller : Slider2D onStartDrag(CallbackListener) 
 controlP5.Controller : Slider2D onWheel(CallbackListener) 
 controlP5.Controller : Slider2D plugTo(Object) 
 controlP5.Controller : Slider2D plugTo(Object, String) 
 controlP5.Controller : Slider2D plugTo(Object[]) 
 controlP5.Controller : Slider2D plugTo(Object[], String) 
 controlP5.Controller : Slider2D registerProperty(String) 
 controlP5.Controller : Slider2D registerProperty(String, String) 
 controlP5.Controller : Slider2D registerTooltip(String) 
 controlP5.Controller : Slider2D removeBehavior() 
 controlP5.Controller : Slider2D removeCallback() 
 controlP5.Controller : Slider2D removeCallback(CallbackListener) 
 controlP5.Controller : Slider2D removeListener(ControlListener) 
 controlP5.Controller : Slider2D removeListenerFor(int, CallbackListener) 
 controlP5.Controller : Slider2D removeListenersFor(int) 
 controlP5.Controller : Slider2D removeProperty(String) 
 controlP5.Controller : Slider2D removeProperty(String, String) 
 controlP5.Controller : Slider2D setArrayValue(float[]) 
 controlP5.Controller : Slider2D setArrayValue(int, float) 
 controlP5.Controller : Slider2D setBehavior(ControlBehavior) 
 controlP5.Controller : Slider2D setBroadcast(boolean) 
 controlP5.Controller : Slider2D setCaptionLabel(String) 
 controlP5.Controller : Slider2D setColor(CColor) 
 controlP5.Controller : Slider2D setColorActive(int) 
 controlP5.Controller : Slider2D setColorBackground(int) 
 controlP5.Controller : Slider2D setColorCaptionLabel(int) 
 controlP5.Controller : Slider2D setColorForeground(int) 
 controlP5.Controller : Slider2D setColorLabel(int) 
 controlP5.Controller : Slider2D setColorValue(int) 
 controlP5.Controller : Slider2D setColorValueLabel(int) 
 controlP5.Controller : Slider2D setDecimalPrecision(int) 
 controlP5.Controller : Slider2D setDefaultValue(float) 
 controlP5.Controller : Slider2D setHeight(int) 
 controlP5.Controller : Slider2D setId(int) 
 controlP5.Controller : Slider2D setImage(PImage) 
 controlP5.Controller : Slider2D setImage(PImage, int) 
 controlP5.Controller : Slider2D setImages(PImage, PImage, PImage) 
 controlP5.Controller : Slider2D setImages(PImage, PImage, PImage, PImage) 
 controlP5.Controller : Slider2D setLabel(String) 
 controlP5.Controller : Slider2D setLabelVisible(boolean) 
 controlP5.Controller : Slider2D setLock(boolean) 
 controlP5.Controller : Slider2D setMax(float) 
 controlP5.Controller : Slider2D setMin(float) 
 controlP5.Controller : Slider2D setMouseOver(boolean) 
 controlP5.Controller : Slider2D setMoveable(boolean) 
 controlP5.Controller : Slider2D setPosition(float, float) 
 controlP5.Controller : Slider2D setPosition(float[]) 
 controlP5.Controller : Slider2D setSize(PImage) 
 controlP5.Controller : Slider2D setSize(int, int) 
 controlP5.Controller : Slider2D setStringValue(String) 
 controlP5.Controller : Slider2D setUpdate(boolean) 
 controlP5.Controller : Slider2D setValue(float) 
 controlP5.Controller : Slider2D setValueLabel(String) 
 controlP5.Controller : Slider2D setValueSelf(float) 
 controlP5.Controller : Slider2D setView(ControllerView) 
 controlP5.Controller : Slider2D setVisible(boolean) 
 controlP5.Controller : Slider2D setWidth(int) 
 controlP5.Controller : Slider2D show() 
 controlP5.Controller : Slider2D unlock() 
 controlP5.Controller : Slider2D unplugFrom(Object) 
 controlP5.Controller : Slider2D unplugFrom(Object[]) 
 controlP5.Controller : Slider2D unregisterTooltip() 
 controlP5.Controller : Slider2D update() 
 controlP5.Controller : Slider2D updateSize() 
 controlP5.Controller : String getAddress() 
 controlP5.Controller : String getInfo() 
 controlP5.Controller : String getName() 
 controlP5.Controller : String getStringValue() 
 controlP5.Controller : String toString() 
 controlP5.Controller : Tab getTab() 
 controlP5.Controller : boolean isActive() 
 controlP5.Controller : boolean isBroadcast() 
 controlP5.Controller : boolean isInside() 
 controlP5.Controller : boolean isLabelVisible() 
 controlP5.Controller : boolean isListening() 
 controlP5.Controller : boolean isLock() 
 controlP5.Controller : boolean isMouseOver() 
 controlP5.Controller : boolean isMousePressed() 
 controlP5.Controller : boolean isMoveable() 
 controlP5.Controller : boolean isUpdate() 
 controlP5.Controller : boolean isVisible() 
 controlP5.Controller : float getArrayValue(int) 
 controlP5.Controller : float getDefaultValue() 
 controlP5.Controller : float getMax() 
 controlP5.Controller : float getMin() 
 controlP5.Controller : float getValue() 
 controlP5.Controller : float[] getAbsolutePosition() 
 controlP5.Controller : float[] getArrayValue() 
 controlP5.Controller : float[] getPosition() 
 controlP5.Controller : int getDecimalPrecision() 
 controlP5.Controller : int getHeight() 
 controlP5.Controller : int getId() 
 controlP5.Controller : int getWidth() 
 controlP5.Controller : int listenerSize() 
 controlP5.Controller : void remove() 
 controlP5.Controller : void setView(ControllerView, int) 
 controlP5.Slider2D : Slider2D disableCrosshair() 
 controlP5.Slider2D : Slider2D enableCrosshair() 
 controlP5.Slider2D : Slider2D setArrayValue(float[]) 
 controlP5.Slider2D : Slider2D setCursorX(float) 
 controlP5.Slider2D : Slider2D setCursorY(float) 
 controlP5.Slider2D : Slider2D setMaxX(float) 
 controlP5.Slider2D : Slider2D setMaxY(float) 
 controlP5.Slider2D : Slider2D setMinMax(float, float, float, float) 
 controlP5.Slider2D : Slider2D setMinX(float) 
 controlP5.Slider2D : Slider2D setMinY(float) 
 controlP5.Slider2D : Slider2D setValue(float) 
 controlP5.Slider2D : Slider2D setValue(float, float) 
 controlP5.Slider2D : Slider2D shuffle() 
 controlP5.Slider2D : float getCursorHeight() 
 controlP5.Slider2D : float getCursorWidth() 
 controlP5.Slider2D : float getCursorX() 
 controlP5.Slider2D : float getCursorY() 
 controlP5.Slider2D : float getMaxX() 
 controlP5.Slider2D : float getMaxY() 
 controlP5.Slider2D : float getMinX() 
 controlP5.Slider2D : float getMinY() 
 controlP5.Slider2D : float[] getArrayValue() 
 controlP5.Slider2D : void setValueLabelSeparator(String) 
 java.lang.Object : String toString() 
 java.lang.Object : boolean equals(Object) 
 
 created: 2015/03/24 12:25:47
 
 */
